#include "qos_client.h"
#include <iostream>
#include <stdint.h>
#include <string.h>
#include <stdio.h>
#include <map>
#include <ei.h>


#include <time.h>
#include <stdarg.h>
# include <stdio.h>
#include <stdlib.h>

#define BUFF_LEN 128
std::map<int, int> reqCache;
bool gIsBigEndian;
char gCmdBuff[BUFF_LEN] = {};
int gIndex = 0;
uint64_t gReqId = 0;

void LOG(const char* ms, ... ) {
    char wzLog[100] = {0};
    char buffer[128] = {0};
    va_list args;
    va_start(args, ms);
    vsprintf(wzLog, ms, args);
    va_end(args);

    time_t now;
    time(&now);
    struct tm *local;
    local = localtime(&now);
    sprintf(buffer, "%04d-%02d-%02d %02d:%02d:%02d %s\n", local->tm_year + 1900, local->tm_mon,local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec,wzLog);
    FILE *file = fopen("debug.log", "a+");
    fwrite(buffer, 1, strlen(buffer), file);
    fclose(file);
    return;
}

int checkEndian(void) {
    union {
        uint16_t i;
        char c[2];
    } value = {0x0102};

    return value.c[0] == 1;
}

uint16_t swapByteOrder(uint16_t ui) {
    ui = ((ui & 0xff00)  >> 8) | ((ui & 0x00ff) << 8);
    return ui;
}

uint16_t readLen(std::istream &s) {
    uint16_t len;
    s.read(reinterpret_cast<char *>(&len), sizeof(len));
    if (!gIsBigEndian)
        len = swapByteOrder(len);
    // std::cerr << 'r' << len << ' ';
    // std::cerr.flush();
    return len;
}

std::ostream &writeLen(std::ostream &s, uint16_t len) {
    // std::cerr << 'w' << len << ' ';
    // std::cerr.flush();

    if (!gIsBigEndian)
        len = swapByteOrder(len);
    s.write(reinterpret_cast<char *>(&len), sizeof(len));
    return s;
}

int main(void) {
    gIsBigEndian = checkEndian();

    // Helps to detect std::cin closing
    std::cin.exceptions(std::istream::failbit | std::istream::badbit);

    // Read buffer's length
    while (true) {
        // read len, 2 bytes
        uint16_t rLen = readLen(std::cin);

        // read data, len bytes
        std::cin.read(gCmdBuff, rLen);
        gIndex = 0;
        int arity = 0;
        LOG("IMY*************00000 %d %s", rLen, gCmdBuff);
        int version = 0;
        ei_decode_version(gCmdBuff, &gIndex, &version);

        ei_decode_tuple_header(gCmdBuff, &gIndex, &arity);

        LOG("IMY*************000111 %d", arity);
        char cmdId;
        ei_decode_char(gCmdBuff, &gIndex, &cmdId);
        LOG("IMY*************11111 %c", cmdId);
        switch (cmdId) {
            case 'i': {          // 初始化sdk
                // get the ip port reqId   先读取 cmdid, cmd
                unsigned long sdkCmdId;
                unsigned long sdkCmd;
                ei_decode_ulong(gCmdBuff, &gIndex, &sdkCmdId);
                ei_decode_ulong(gCmdBuff, &gIndex, &sdkCmd);
                DebugLog("IMY************init %d %d \n", sdkCmdId, sdkCmd);
                int ret = 0;
                gIndex = 0;
                memset(gCmdBuff, 0, BUFF_LEN);
                ei_encode_version(gCmdBuff, &gIndex);
                ei_encode_tuple_header(gCmdBuff, &gIndex, 1);
                ei_encode_long(gCmdBuff, &gIndex, ret);
                writeCmd(gCmdBuff, gIndex);
            }
                break;
            case 'g': {              // 获取Ip:port
                // get the ip port reqId   先读取 cmdid, cmd
                unsigned long sdkCmdId;
                unsigned long sdkCmd;
                ei_decode_ulong(gCmdBuff, &gIndex, &sdkCmdId);
                ei_decode_ulong(gCmdBuff, &gIndex, &sdkCmd);
                DebugLog("IMY************getip %d %d \n", sdkCmdId, sdkCmd);
                uint64_t reqId = 0;
                gIndex = 0;
                memset(gCmdBuff, 0, BUFF_LEN);
                ei_encode_version(gCmdBuff, &gIndex);
                ei_encode_tuple_header(gCmdBuff, &gIndex, 3);
                ei_encode_ulong(gCmdBuff, &gIndex, reqId);
                REQCACHE cache = reqCache[reqId];
                ei_encode_string(gCmdBuff, &gIndex, cache.req._host_ip.c_str());
                ei_encode_ulong(gCmdBuff, &gIndex, cache.req._host_port);
                writeCmd(gCmdBuff, gIndex);
            }
                break;
            default:
                break;
        }
    }
    return 0;
}
