-module(ePortMsg).

-export([
   port_call/2,
   port_cast/2
]).

port_call(Port, Msg) ->
   Port ! {self(), {command, term_to_binary(Msg)}},
   receive
      {Port, {data, DataBin}} ->
         io:format("~p~n", [DataBin]),
         {ok, binary_to_term(DataBin)};
      {Port, closed} ->
         {error, closed};
      {'EXIT', Port, Reason} ->
         {'EXIT', Reason}
   after 4000 ->
      timeout
   end.

port_cast(Port, Msg) ->
   Port ! {self(), {command, term_to_binary(Msg)}}.